--------------------------------------------------------------------------------
--	Script file guard
--	Examine its value to see how many times the script was run.
--------------------------------------------------------------------------------
 if (guardLtbL_functions == undefined) then
 (
 	global guardLtbL_functions = 0
 )	

 guardLtbL_functions += 1
 
 --------------------------------------------------------------------------------------
 ---
 --------------------------------------------------------------------------------------
Global sfSky
Global sfSun
 
fn SF_heavens = (
	environmentMap = mr_Physical_Sky ()
	messageBox "Heavens have been created!\nClick on one of the \"Set Rig for\" buttons:\n\nDay -- Maxis Nite -- Dark Nite\n\nto finalise Sky Settings"
)

fn SF_earth = (
	gRound_Layer = layerManager.getLayerFromName "BAT ground plane"
	if	gRound_Layer != undefined then(
	gRound_Layer.current =true
	gRound_Layer.isHidden = False
	gRound_Layer.isFrozen = true
	)
else (
	gRound_Layer = LayerManager.newLayerFromName "BAT ground plane"
	gRound_Layer.current =true
	gRound_Layer.isHidden = false
	gRound_Layer.isFrozen = true
	)
	

	sfGround = getNodeByName "the_Earth_sf"
	if sfGround != undefined do delete sfGround
	sfGround= plane  length: 1000 width: 1000 name: "the_Earth_sf"
	select sfGround
	if (maxVersion())[1] >11000 do 
		(
			messageBox "For optimal lighting conditions in the following Dialog window do:\n1. select Mental Ray tab\n2. in Final Gather section choose \"Pass through (Invisible to FG)\" option\n3. click OK button to close dialog"
			actionMan.executeAction 0 "40022"  -- Edit: Properties
		)
	deselect sfGround
	sfGround.primaryVisibility = off
		
	(LayerManager.getLayer 0).current = true
	MessageBox "ground has been created!"
	
)

fn SF_Glare = (
	MaxisNiteSky = getNodeByName "IES Sky | Maxis nite"
	DarkNiteSky = getNodeByName "IES Sky | Dark nite"
	If  MaxisNiteSky != undefined then 
		(
			myRen = renderers.current
			myRen.Enable_Camera_output_Shader =true
			myGlare = myRen.Camera_Output_Shader
			myGlare.name = "MyGlare"
			myGlare.Quality = 3
			myGlare.Calculation_Resolution = 1500
			myGlare.spread = 2
			myGlare.Streaks = true
			myGlare.contrast = 0.965
			myGlare.Streak_Image = "glare_streaks_star_camera_filter.tif"
			messageBox "Glare for Maxis Nite is set.\n\nYou may manually edit settings by dragging the instance of Glare Map from Camera Output Shader to any slot in Material Editor."
		)
		else
		(
			if DarkNiteSky != undefined then 
			(
				myRen = renderers.current
				myRen.Enable_Camera_output_Shader =true
				myGlare = myRen.Camera_Output_Shader
				myGlare.name = "MyGlare"
				myGlare.Quality = 3
				myGlare.Calculation_Resolution = 1500
				myGlare.spread = 2
				myGlare.Streaks = true
				myGlare.contrast = 0.965
				myGlare.Streak_Image = "glare_streaks_star_camera_filter.tif"
				messageBox "Glare for Dark Nite is set.\n\nYou may manually edit settings by dragging the instance of Glare Map from Camera Output Shader to any slot in Material Editor."
			)
			else messageBox "Glare is TruNite effect. Set night rig by pressing\n\n-Maxis Nite- or -Dark Nite-\n\nbutton first"
		)
)
 
fn FN_SF_BatRigLaeyerSetter = (
Bat_Rig_Layer = layerManager.getLayerFromName "BAT Rig"

if	Bat_Rig_Layer != undefined then(
	Bat_Rig_Layer.current =true
	Bat_Rig_Layer.isHidden = true
	Bat_Rig_Layer.isFrozen = true
	)
else (
	Bat_Rig_Layer = LayerManager.newLayerFromName "BAT Rig"
	Bat_Rig_Layer.current =true
	Bat_Rig_Layer.isHidden = true
	Bat_Rig_Layer.isFrozen = true
	)
)


fn FN_ClearRig = 	(
	lt = $Lights as array
		for n = 1 to lt.count do 
			(	 
				if lt[n] !=undefined and not isDeleted lt[n] do
				(
					if lt[n].parent != undefined do (
							if (lt[n].classID[1] != 4128) and lt[n].parent.name == "TB2CameraHandle" do delete lt[n]
						)
				)
				
			)
)

fn SetUnits = (
	units.SystemType = #meters
	units.SystemScale = 1.0
	units.DisplayType = #metric
)


-----------------------------------------------------------------------------
--              Rigs                                                     
-----------------------------------------------------------------------------

/* day rig MrSun + IES Sky Max 2k series */

fn SFRig1 = (
	
	sfSky = IES_Sky pos:[0,0,575] target:(Targetobject transform:(matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0])) sky_cover:0.5 multiplier:1.1 color:(color 144 144 255)
	sfSun = mr_Sun useGlobalShadowSettings:off pos:[-474,-352,575] target:(Targetobject transform:(matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0])) inherit:off redblueshift:0.02 saturation:1.32 shadowSamples:16 shadowSoftness:1.5 name:"MR | Sun"
	sfSun.target.name = "MR | Sun target"
)

/* day rig IES Sun + IES Sky Max 7-9 */
fn SFRig2 = (
	
	sfSun = IES_Sun pos:[-474,-352,575] target:(Targetobject transform:(matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0])) multiplier:84000 rgb:(color 255 237 197) castShadows:on name: "IES | Sun"
	sfSky = IES_Sky pos:[0,0,575] target:(Targetobject transform:(matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0])) sky_cover:0.5 multiplier:1.0 color:(color 185 190 255)
		
	sfSun.shadowGenerator = RaytraceShadow()
	sfSun.raytraceBias = 0.0
	sfSun.maxDepth = 10
	sfSun.target.name = "IES | Sun target"
)

/* nite Rig Maxis Max 2k Series */
fn SFRig3 = (
	sfSky = IES_Sky pos:[-474,-352,575] target:(Targetobject transform:(matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0])) sky_cover:0.0 multiplier:0.025 color:(color 105 101 255)
	)


/*nite Rig Dark  Max 2k Series*/
fn SFRig4 = (
	sfSky = IES_Sky pos:[-474,-352,575] target:(Targetobject transform:(matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0])) sky_cover:0.0 multiplier:0.015 color:(color 41 41 85)
)

/* nite Rig Maxis Max 7-9 */
fn SFRig5 = (
	sfSky = IES_Sky pos:[-474,-352,575] target:(Targetobject transform:(matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0])) sky_cover:0.0 multiplier:0.025 color:(color 155 153 236)
)


/*nite Rig Dark Max 7-9 */
fn SFRig6 = (
	sfSky = IES_Sky pos:[-474,-352,575] target:(Targetobject transform:(matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0])) sky_cover:0.0 multiplier:0.015 color:(color 58 58 88)
)




-----------------------------------------------------------------------------
--               Gamma Correction                     
-----------------------------------------------------------------------------

/* DAY ExposureControl settings for Max2k8 anf newer */
fn SFGC1 = (
myGC = mr_Photographic_Exposure_Control()
SceneExposureControl.exposureControl = myGC
myGC.active = true
myGC.f_stop = 8
myGC.shutter_speed = 512
myGC.film_isoUI =200.0
myGC.physical_scale_mode = 1
myGC.saturation = 1.25
myGC.whitepointKelvin = 10
--myGC.whitePoint = (color 249 255 247)
)


/* NITE ExposureControl settings for Max2k8 */
fn SFGC2 = (
myGC = mr_Photographic_Exposure_Control()
SceneExposureControl.exposureControl = myGC
myGC.active = true
myGC.f_stop = 8
myGC.shutter_speed = 6
myGC.film_isoUI =200.0
myGC.physical_scale_mode = 1
myGC.whitepointKelvin = 10
--myGC.whitePoint = (color 183 255 160)
)

/* DAY ExposureControl Settings for Max7-9 */
fn SFGC3 = (
myGC = Logarithmic_Exposure_Control()
SceneExposureControl.exposureControl = myGC
myGC.active = true
if ((maxVersion())[1]) >= 9000 do (
	myGC.useLegacyAlgorithm = true
	)
myGC.daylight = true
myGC.brightness = 68.0
myGC.contrast = 60.0
myGC.chromaticAdaptation = false
myGC.colorDifferentiation = false
myGC.daylight = true
myGC.exterior = true
myGC.physicalScale = 1500.0
-- myGC.chromaticAdaptation = false
-- myGC.whiteColor = (color 255 240 218)
)


/* NITE Maxis ExposureControl Settings for Max7-9 */
fn SFGC4 = (
myGC = Logarithmic_Exposure_Control()
SceneExposureControl.exposureControl = myGC
myGC.active = true
if ((maxVersion())[1]) >= 9000 do (
	myGC.useLegacyAlgorithm = true
	)
myGC.daylight = true
myGC.brightness = 65.0
myGC.contrast = 27.0
myGC.chromaticAdaptation = false
myGC.colorDifferentiation = true
myGC.daylight = false
myGC.exterior = false
myGC.physicalScale = 1500.0
-- myGC.whiteColor = (color 255 255 255)
)

/* NITE DARK ExposureControl Settings for Max7-9 */
fn SFGC5 = (
myGC = Logarithmic_Exposure_Control()
SceneExposureControl.exposureControl = myGC
myGC.active = true
if ((maxVersion())[1]) >= 9000 do (
	myGC.useLegacyAlgorithm = true
	)
myGC.daylight = true
myGC.brightness = 65.0
myGC.contrast = 25.0
myGC.chromaticAdaptation = false
myGC.colorDifferentiation = true
myGC.daylight = false
myGC.exterior = false
myGC.physicalScale = 1500.0
myGC.whiteColor = (color 255 255 255)
)



-----------------------------------------------------------------------------
--               Final Gather                                
-----------------------------------------------------------------------------

/* FG day settings "normal" Max 9-2k8 */
fn SFFG1 = (
	renderers.current = mental_ray_renderer()
	myRen = renderers.current
	myRen.MinimumSamples = 0
	myRen.MaximumSamples = 2
	myRen.filter =4
	myRen.RedSpatialContrast = 0.02
	myRen.GreenSpatialContrast = 0.02
	myRen.BlueSpatialContrast = 0.02
	myRen.AlphaSpatialContrast = 0.02
	myRen.FinalGatherEnable2 = true
	myRen.FinalGatherDensity =1.5
	myRen.FinalGatherAccuracy = 180
	myRen.FinalGatherBounces = 3
)

/*FG day and Nite settings "normal" Max 7 */
fn SFFG2 = (
	renderers.current = mental_ray_renderer()
	myRen = renderers.current
	myRen.MinimumSamples = 0
	myRen.MaximumSamples = 2
	myRen.filter =4
	myRen.FinalGatherEnable2 = true
	myRen.FinalGatherAccuracy = 300
	myRen.FinalGatherView = true
)

/*FG nite settings "normal" Max 9-2k8+ */
fn SFFG3 = (
	renderers.current = mental_ray_renderer()
	myRen = renderers.current
	myRen.MinimumSamples = 0
	myRen.MaximumSamples = 2
	myRen.filter =4
	myRen.RedSpatialContrast = 0.02
	myRen.GreenSpatialContrast = 0.02
	myRen.BlueSpatialContrast = 0.02
	myRen.AlphaSpatialContrast = 0.02
	myRen.FinalGatherEnable2 = true
	myRen.FinalGatherDensity =1.5
	myRen.FinalGatherAccuracy = 180
	myRen.FinalGatherBounces = 1
)

/*FG day settings "normal" Max 8 */
fn SFFG4 = 
	(
	renderers.current = mental_ray_renderer()
	myRen = renderers.current
	myRen.MinimumSamples = 0
	myRen.MaximumSamples = 2
	myRen.filter =4
	myRen.FinalGatherEnable2 = true
	myRen.FinalGatherAccuracy = 150
	myRen.FinalGatherView = true
	myRen.FinalGatherBounces = 3
	)

/*FG nite settings "normal" Max 8 */
fn SFFG5 = 
(
	renderers.current = mental_ray_renderer()
	myRen = renderers.current
	myRen.MinimumSamples = 0
	myRen.MaximumSamples = 2
	myRen.filter =4
	myRen.FinalGatherEnable2 = true
	myRen.FinalGatherAccuracy = 300
	myRen.FinalGatherView = true
	myRen.FinalGatherBounces = 1
)	

/* Creates Day Rig and sets evertyhing for day render scene*/
fn SF_SetDay = 
(
	FN_SF_BatRigLaeyerSetter ()
	FN_ClearRig ()
	gCameraRig.SetCam 5 1 updateViewport:false 
	RigXref = xrefs.getXrefFile 1
	RigXRef.hidden = true
	local thisMax = (maxVersion())[1]
	
	if thisMax >= 10000 then (
		SFRig1 ()
		SFGC1 ()
		SFFG1 ()
		SetUnits ()
		if useEnvironmentMap and hasProperty environmentMap "sunglow" then (
			local sfSkyMap = environmentMap
			sfSkyMap.InheritFromSky = false
			sfSkyMap.Multiplier = 2.0
			sfSkyMap.haze = 3.0
			sfSkyMap.GroundColor = (color 20 19 18)
			sfSkyMap.HorizonHeight = 0.0
			sfSkyMap.Saturation = 1.0
			sfSkyMap.SunIntensity = 1.0
			sfSkyMap.SunGlow= 1.0
			sfSkyMap.SunScale = 4.0
			)
			else (
				backgroundColor = (color 65 65 65)
			)
	)
		else (
			if thisMax >=9000 and thisMax < 10000 then (
				backgroundColor = (color 65 65 65)
				SFRig2 ()
				SFGC3 ()
				SFFG1 ()
				SetUnits ()
				)
			else (
				if thisMax >= 8000 and thisMax < 9000 then (
					backgroundColor = (color 65 65 65)
					SFRig2 ()
					SFGC3 ()
					SFFG4 ()
					SetUnits ()
				)
				else (
					if thisMax>=7000 and thisMax< 8000 then (
						backgroundColor = (color 65 65 65)
						SFRig2 ()
						SFGC3 ()
						SFFG2 ()
						SetUnits ()
					)
					else messageBox "sorry, only 3dsMax version 7.0 and greater are supported"
				)
				
				
			)
		)
	sfSky.name = "IES Sky | Day"
	sfSky.target.name = "IES Sky | Day target"
	sfSun.parent = $TB2CameraHandle
	sfSky.Parent = $TB2CameraHandle
	freeze $TB2CameraHandle
	hide $TB2CameraHandle
	(LayerManager.getLayer 0).current = true
)

fn SF_SetMaxisNite =
(
	FN_SF_BatRigLaeyerSetter ()
	FN_ClearRig ()
	gCameraRig.SetCam 5 1 updateViewport:false 
	RigXref = xrefs.getXrefFile 1
	RigXRef.hidden = true
	
	local thisMax = (maxVersion())[1]
	
	if thisMax >= 10000 then (
		SFRig3 ()
		SFGC2 ()
		SFFG3 ()
		SetUnits ()
		if useEnvironmentMap and hasProperty environmentMap "sunglow" then (
			local sfSkyMap = environmentMap
			sfSkyMap.InheritFromSky = false
			sfSkyMap.Multiplier = 0.002
			sfSkyMap.haze = 0.0
			sfSkyMap.HorizonHeight = -7.0
			sfSkyMap.Saturation = 0.75
			sfSkyMap.GroundColor = (color 38 33 45)
			sfSkyMap.SunIntensity = 0.0
			sfSkyMap.SunGlow= 0.0
			sfSkyMap.SunScale = 0.0
		)
		else (
			backgroundColor = (color 20 20 30)
		)
	)
	else (
		if thisMax >=9000 and thisMax < 10000 then (
			backgroundColor = (color 40 40 60)
			SFRig5 ()
			SFGC4 ()
			SFFG3 ()
			SetUnits ()
			)
		else (
			if thisMax >= 8000 and thisMax < 9000 then (
				backgroundColor = (color 40 40 60)
				SFRig5 ()
				SFGC4 ()
				SFFG5 ()
				SetUnits ()
			)
			else (
				if thisMax >= 7000 and thisMax < 8000 then (
					backgroundColor = (color 40 40 60)
					SFRig5 ()
					SFGC4 ()
					SFFG2 ()
					SetUnits ()
					)
					else messageBox "sorry, only 3dsMax version 7.0 and greater are supported"
				)
		)	
	)
	sfSky.name = "IES Sky | Maxis nite"
	sfSky.target.name = "IES Sky | Maxis nite target"
	sfSky.Parent = $TB2CameraHandle
	freeze $TB2CameraHandle
	hide $TB2CameraHandle
	(LayerManager.getLayer 0).current = true	
)

fn SF_SetDarkNite =
(
	FN_SF_BatRigLaeyerSetter ()
	FN_ClearRig ()
	gCameraRig.SetCam 5 1 updateViewport:false 
	RigXref = xrefs.getXrefFile 1
	RigXRef.hidden = true
	
	local thisMax = (maxVersion())[1]
		if thisMax >= 10000 then (
			SFRig4 ()
			SFGC2 ()
			SFFG3 ()
			SetUnits ()
			if useEnvironmentMap and hasProperty environmentMap "sunglow" then (
				local sfSkyMap = environmentMap
				sfSkyMap.InheritFromSky = false
				sfSkyMap.Multiplier = 0.00075
				sfSkyMap.haze = 0.0
				sfSkyMap.HorizonHeight = -7.0
				sfSkyMap.Saturation = 1.0
				sfSkyMap.GroundColor = (color 15 13 18)
				sfSkyMap.SunIntensity = 0.0
				sfSkyMap.SunGlow= 0.0
				sfSkyMap.SunScale = 0.0
			)
			else (
				backgroundColor = (color 4 4 6)
			)
		)
		else (
			if thisMax >=9000 and thisMax < 10000 then (
				backgroundColor = (color 14 7 18)
				SFRig6 ()
				SFGC5 ()
				SFFG3 ()
				SetUnits ()
				)
			else (
				if thisMax >= 8000 and thisMax < 9000 then (
					backgroundColor = (color 14 7 18)
					SFRig6 ()
					SFGC5 ()
					SFFG5 ()
					SetUnits ()
				)
				else (
					if thisMax >=7000 and thisMax < 8000 then (
						backgroundColor = (color 14 7 18)
						SFRig6 ()
						SFGC5 ()
						SFFG2 ()
						SetUnits ()
						)
						else messageBox "sorry, only 3dsMax version 7.0 and greater are supported"
					)
			)
		)
			
			
		
	
	sfSky.name = "IES Sky | Dark nite"
	sfSky.target.name = "IES Sky | Dark Nite target"
	sfSky.Parent = $TB2CameraHandle
	freeze $TB2CameraHandle
	hide $TB2CameraHandle
	(LayerManager.getLayer 0).current = true
)

fn SF_DarkenTheNite =
(
	ltALL = $Lights as array
	if ltAll.count >0 then
	(
		RigLights =#()
		for n =1 to ltAll.count do
		(
			if ltAll[n].parent != undefined and ltAll[n].parent.name == "TB2CameraHandle" do
			(
				append RigLights ltAll[n]
			)			
		)
		if RigLights.count >0 then
		(
			for i = 1 to RigLights.count do
			(
				case RigLights[i].name of
				(
					"IES Sky | Dark nite" : messageBox "It's dark as is!"
					"IES Sky | Maxis nite": (
													RigLights[i].multiplier = 0.015 
													RigLights[i].color = (color 41 41 85)
													RigLights[i].name = "IES Sky | Dark nite"
													RigLights[i].target.name = "IES Sky | Dark nite target"
													if useEnvironmentMap and hasProperty environmentMap "sunglow" then (
														local sfSkyMap = environmentMap
														sfSkyMap.InheritFromSky = false
														sfSkyMap.Multiplier = 0.00075
														sfSkyMap.haze = 0.0
														sfSkyMap.HorizonHeight = -7.0
														sfSkyMap.Saturation = 1.0
														sfSkyMap.GroundColor = (color 15 13 18)
														sfSkyMap.SunIntensity = 0.0
														sfSkyMap.SunGlow= 0.0
														sfSkyMap.SunScale = 0.0
														)
														else (
															backgroundColor = (color 4 4 6)
														)
														messageBox "it's DarkNite now!"
												)
					"IES Sky | Day": messageBox "it's day, silly!"
				)
			)
		)
		else messageBox "no LtbL rig  is present in the scene \ncreate it first"
	)
	else messageBox "there are no lights of any kind in the scene"

)	
	

fn SF_BrightenTheNite= 
(
	ltALL = $Lights as array
	if ltAll.count >0 then
	(
		RigLights =#()
		for n =1 to ltAll.count do
		(
			if ltAll[n].parent != undefined and ltAll[n].parent.name == "TB2CameraHandle" do
			(
				append RigLights ltAll[n]
			)			
		)
		if RigLights.count >0 then
		(
			for i = 1 to RigLights.count do
			(
				case RigLights[i].name of
				(
					"IES Sky | Dark nite" : (
													RigLights[i].multiplier = 0.025
													RigLights[i].color = (color 105 101 255)
													RigLights[i].name = "IES Sky | Maxis nite"
													RigLights[i].target.name = "IES Sky | Maxis nite target"
													if useEnvironmentMap and hasProperty environmentMap "sunglow" then (
													local sfSkyMap = environmentMap
													sfSkyMap.InheritFromSky = false
													sfSkyMap.Multiplier = 0.002
													sfSkyMap.haze = 0.0
													sfSkyMap.HorizonHeight = -7.0
													sfSkyMap.Saturation = 0.75
													sfSkyMap.GroundColor = (color 38 33 45)
													sfSkyMap.SunIntensity = 0.0
													sfSkyMap.SunGlow= 0.0
													sfSkyMap.SunScale = 0.0
													)
													else (
														backgroundColor = (color 20 20 30)
													)
													messageBox "it's Maxis Nite now!"
												)
					"IES Sky | Maxis nite": messageBox "It's Maxis Nite already"
					"IES Sky | Day": messageBox "it's day, silly!"
				)
			)
		)
		else messageBox "no LtbL rig is present in the scene \ncreate it first"
	)
	else messageBox "there are no lights of any kind in the scene"
)